<?php
class Translator {
    private $db;
    private $lang = '';
    private $src = array();
    public static function GetInstance($page = 'default.php', $lang = 'hu', $connStr = false, $user = null, $pass = null) {
        static $instance = null;
        if(null === $instance) {
            $instance = new static($page, $lang, $connStr, $user, $pass);
        }
        return $instance;
    }
    protected function __construct($page, $lang, $connStr, $user, $pass) {
        $this->lang = $lang;
        if($connStr) {
            $this->db  = new PDO($connStr, $user, $pass);
            $this->src = $this->GetSrcFromDb($page);
        } else {
            $this->src = include_once($page);
        }
    }
    private function GetSrcFromDb($page) {
        $resArray = array();
        $sql      = "SELECT * FROM Languages WHERE page = ?;";
        $query    = $this->db->prepare($sql);
        $query->execute(array(
            $page
        ));
        while ($row = $query->fetch(PDO::FETCH_ASSOC)) {
            foreach ($row as $key => $value) {
                if($key != 'exp' && $key != 'id'){
                	$resArray[$row['exp']][$key] = $value;
                }
            }
        }
        return $resArray;
    }
    public function SetLang($lang) {
        $this->lang = $lang;
    }
    public function T($word, $lang = false) {
        if(!$lang){
        	$lang = $this->lang;
        } 
        if(isset($this->src[$word][$lang])) {
            return $this->src[$word][$lang];
        } else {
            return $word;
        }
    }
}
